//+------------------------------------------------------------------+
//|                                               e-Droba-ZigZag.mq4 |
//|                                  Copyright  2010, Michelangelo |
//|                                                www.fxgeneral.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Michelangelo"
#property link      "www.fxgeneral.com"
#define MAGICMA  20100930

extern int     ExtDepth      = 12;
extern int     ExtDeviation  = 5;
extern int     ExtBackstep   = 3;
extern int     _point        = 0;
extern double  _lots         = 0.1;
extern int     _takeProfit   = 70;
//extern int     _stopLoss     = 80;
extern int     BBUSize       = 10;    //        
extern int     BBUSizepip    = 10;    //  
extern bool    _trailingStop = true;
extern int     _maPeriod     = 100;


double _lastExtremum=0.0;
double _currentExtremum=0.0;
double _previousExtremum=0.0;
int _extType=-1;
double _workLots=0.0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int err1;
   int ticket=0;
   double _sl=0.0, _tp=0.0;
   double _price=0.0;
   double _ma=0.0;

 if(BBUSize>0){err1=BBU();}
   
//----
   if (Volume[0]>1) return;
   if (_trailingStop) _TrailingStop();
   _ma=iMA(Symbol(),0,_maPeriod,0,0,PRICE_CLOSE,0);
   _lastExtremum=GetExtremumZZPrice(1);
   Comment (_lastExtremum);
   if (Close[0]<_lastExtremum){
      if (_extType!=OP_BUYSTOP){
//         _CheckOrder(OP_BUYSTOP);
         _price=NormalizeDouble((_lastExtremum+_point*Point),Digits);
        /* if (_stopLoss>0)*/ _sl=NormalizeDouble(_ma-10*Point,Digits);
         if (_takeProfit>0) _tp=NormalizeDouble(_price+_takeProfit*Point,Digits);
         _extType=OP_BUYSTOP;
        if (_lastExtremum>_ma)
         ticket=OrderSend(Symbol(),_extType,_lots,_price,5,_sl,_tp,"e-Droba",MAGICMA,0,0);
      }
   }
   if (Close[0]>_lastExtremum){
      if (_extType!=OP_SELLSTOP){
//         _CheckOrder(OP_SELLSTOP);
         _price=NormalizeDouble((_lastExtremum-_point*Point),Digits);
        /* if (_stopLoss>0)*/ _sl=NormalizeDouble(_ma+10*Point,Digits);
         if (_takeProfit>0) _tp=NormalizeDouble(_price-_takeProfit*Point,Digits);
         _extType=OP_SELLSTOP;
         if (_lastExtremum<_ma)
         ticket=OrderSend(Symbol(),_extType,_lots,_price,5,_sl,_tp,"e-Droba",MAGICMA,0,0);
      }
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
double GetExtremumZZPrice(int ne=0) {
   double zz;   
   int    i, k=iBars(Symbol(), 0), ke=0;
   for (i=1; i<k; i++) {
      zz=iCustom(Symbol(),0, "ZigZag", ExtDepth,ExtDeviation,ExtBackstep,0,i);
      if (zz!=0) {
         ke++;
         if (ke>ne) return(zz);     
      }   
   }   
   return(0); 
} 
//+------------------------------------------------------------------+
/*int _CheckOrder(int _checkType=0){
   int i;
   if (OrdersTotal()>0){
      for (i=0; i<=OrdersTotal()-1; i++){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
            if (OrderType()==_checkType && OrderMagicNumber()==MAGICMA) OrderDelete(OrderTicket());
         }
      }
   }
   return(0);
}*/
//+------------------------------------------------------------------+
int  BBU()
{//  http://fxnow.ru/blog/programming_mql4/2.html
int i;bool err;
   for( i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {   
        if(BBUSize>0 && OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderStopLoss()<OrderOpenPrice())  
        {                
         if(Bid-OrderOpenPrice()>=BBUSize*Point && BBUSize>0 )
          {
           Print("  ");
           err=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+BBUSizepip*Point,OrderTakeProfit(),0,Green);
           if(err==false){return(-1);}
          }//if(Bid-OrderOpenPrice()
         }//if(BBUSize>0
        }//if(OrderSelect(i
            
       if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {
        if(BBUSize>0 && OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0))  
        {        
         if(OrderOpenPrice()-Ask>=BBUSize*Point && BBUSize>0)
          {
           Print("  ");
           err=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-BBUSizepip*Point,OrderTakeProfit(),0,Green);
           if(err==false){return(-1);}
          }//if(OrderOpenPrice()
         }//if(BBUSize>0 
       }// if(OrderSelect
    }// for( i=1;
return(0);
}
//+------------------------------------------------------------------+
void _TrailingStop(){
   int i;
   double _stopLossSell=NormalizeDouble(iMA(Symbol(),0,_maPeriod,0,0,PRICE_CLOSE,0)+10*Point,Digits),
          _stopLossBuy=NormalizeDouble(iMA(Symbol(),0,_maPeriod,0,0,PRICE_CLOSE,0)-10*Point,Digits),
          _stopLossSellF=NormalizeDouble(iFractals(Symbol(),0,MODE_UPPER,3),Digits),
          _stopLossBuyF=NormalizeDouble(iFractals(Symbol(),0,MODE_LOWER,3),Digits);
   if (OrdersTotal()>0){
      for (i=OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i, SELECT_BY_POS)){
            if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA){
               if (OrderType()==OP_BUY && OrderStopLoss()<OrderOpenPrice()){
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
                  OrderModify(OrderTicket(),OrderOpenPrice(),_stopLossBuy,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
               }
               if (OrderType()==OP_BUY && OrderStopLoss()>OrderOpenPrice() && OrderStopLoss()<_stopLossBuyF){
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
                  OrderModify(OrderTicket(),OrderOpenPrice(),_stopLossBuyF,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
               }
               if (OrderType()==OP_SELL && OrderStopLoss()>OrderOpenPrice()){
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
                  OrderModify(OrderTicket(),OrderOpenPrice(),_stopLossSell,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
               }
               if (OrderType()==OP_SELL && OrderStopLoss()<OrderOpenPrice() && OrderStopLoss()>_stopLossSellF && _stopLossSellF!=0.0){
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
                  OrderModify(OrderTicket(),OrderOpenPrice(),_stopLossSellF,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
               }
            }
         }
      }
   }
return;
}